/** 
 * @file WinMain.cpp
 * @brief WIN32 API𗘗pvÕGg[|CgpW[
 * @author Iwata Naoki -> Y.Katayama
 * @date 2011-03-19
 * @version 1.00
 * @version 1.01 2013/03/21 katayama
 * @version 1.02 2014/10/02 katayama
 * @version 1.03 2015/05/07 katayama
 *
 * Copyright (C) 2008 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]gp܂B
 */

/** \mainpage
 * 2013NuKTv
 */


/*--------- 萔` ---------*/

#define TITLE         ("TPIP3 PC window")	//!< @brief AvP[Ṽ^Cg
#define WINDOW_WIDTH  (1024)					//!< @brief EBhẺ
#define WINDOW_HEIGHT ( 708)					//!< @brief EBhȄc


/*--------- include ---------*/

#include <Windows.h>        // Win32API֌W

#include "TPIP3.h"          // TPIP֌W
#include "WindowManager.h"  // EBhE֌W
#include "sub_module.h"


/*--------- ֐` ---------*/

/**
 * TuVXeWindowsɂۂ̃vÕGg[|Cg(ԍŏɎs֐)\n
 * Cxg̏@link EventListener.cpp @endlinkŎ
 *
 * @param[in] hInstance     ݂̃CX^X
 * @param[in] hPrevInstance ȑÕCX^X
 * @param[in] szCmdLine     R}hC
 * @param[in] iCmdShow      EBhE̕\@
 *
 * @see http://msdn.microsoft.com/en-us/library/ms633559(VS.85).aspx
 *
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow) {
	
	HWND hwnd; // EBhEnh
	MSG  msg;  // Cxg̃bZ[W

	hwnd = createMainWindow(hInstance, TITLE, 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT);	// EBhE̐

	Font_init();
	TPGM_create(hwnd, QVGA, NULL);	// 摜ԁiT[tFCXj𐶐
	TPGC_init(hInstance, hwnd);		// Q[Rg[͊֐̏

	TPJT_set_video_inf(QVGA);		// Jf̉𑜓xw肷
	TPJT_init(IP, hwnd);			// ʐM̐ݒ
	TPJT_set_com_req(0x01, 0);		// ʐMe̐ݒ(f`̂)

	ShowWindow(hwnd, iCmdShow);		// EBhE̕\

	// Cxg
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
