/*-----------------------------------------------------------------
  sub_module.cpp -- Subroutine Module
                   Yuji Katayama ,  2003.11
  ---------------------------------------------------------------*/
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sub_module.h"

/** ̎w蕶wuɒu֐
 *  void str_repl(char *rd_msg, char s_char,char p_char )
 * @param  rd_msg    : ͕
 * @param  s_char    : 
 * @param  p_char    : u
 * @retval rd_msg    : o͕i͕ҏW܂j
 */
void str_repl(char *rd_msg, char s_char,char p_char )
{
	char *msg;

	msg = rd_msg;
	if ( s_char == p_char ) return;
	while ((msg = strchr( msg, s_char ))!=NULL)  msg[0]= p_char ;
}

/** w蕶񂪂邩āA LΎw蕶ȍ~؂藣B
 *  void str_cut(char* rd_msg,char* scan_word)
 * @param  rd_msg    : ͕
 * @param  scan_word : 
 * @retval rd_msg    : o͕i͕ҏW܂j
 */
void str_cut(char* rd_msg,char* scan_word)
{
	char* n;

		n = strstr(rd_msg,scan_word);
		if (n != NULL) *n = 0;
}

//
//@	㉺Jbg
//
int Limit(int num,int min,int max)
{
	if (num < min)  num = min;
	if (num > max)  num = max;

	return num;
}

//
//   ړ(Moving Average)@[`
//
int mov_avr(int val)
{
	static int indx  = 0 ;
	static int num[4] = {0,0,0,0} ;
	int i ;
	int add_num ;

	num[indx] = val ;
	indx = (indx+1)% 4 ;

	add_num = 0 ;
	for ( i = 0 ; i < 4 ; i++ )
	{
		add_num = add_num + num[i] ;
	}

	return (add_num / 4) ;
}

//-------------------------------------------------
//   ړ(Moving Average)@[` Class֐
//-------------------------------------------------

//@
MV_avr::MV_avr()
{
	num = NULL;
}

//@
MV_avr::~MV_avr()
{
	if (num)  delete[] num;
}

//@ړρ@
void MV_avr::init(int mx)
{
	num = new int[mx];
	if (num) {
		mx_cnt = mx;
		cnt = 0;
		inx = 0;
		addsum = 0;
		memset(num, 0, (sizeof(int)) * mx);
	}
}

//  ړώZo
int MV_avr::cal(int val)
{
	addsum = addsum - num[inx];
	addsum = addsum + val;
	num[inx] = val;
	if (cnt < mx_cnt) cnt++;
	inx = (inx + 1)% mx_cnt;
	return (addsum / cnt);
}


//---------------------------------------------
//  Check File
//---------------------------------------------
int Chk_File( char* file_name )
{
	FILE *stream;
	int  res ;

	res = 0 ;
	stream = fopen( file_name, "r" );
	if( stream != NULL )
	{
		fclose( stream );
		res = 5 ;
	}
	return (res);
}

//
//	o͒l@Wϊ
//
int rang_chg(int x,int x_min,int x_max,int y_min,int y_max)
{
	float x_span,y_span;
	float a,b,_y;
	int   y;

	x = Limit( x, x_min, x_max);
	x_span = (float)(x_max - x_min);
	y_span = (float)(y_max - y_min);
	a      =  y_span / x_span ;
	b      = (float)y_min -(a * x_min);
	_y     = (a * x + b);
	y      = (int)((_y >=0) ? (_y+0.5) : (_y-0.5));
	return (y);
}

/** o͒l@Wϊ ֐msяtn
 *  int rang_chg_dzoon(int x,int x_min,int x_max,int y_min,int y_max,int dzoon)
 * @param  x     : ͒l
 * @param  x_min : ͒lf[^͈́ilj
 * @param  x_max : ͒lf[^͈́ilj
 * @param  y_min : o͒lf[^͈́ilj
 * @param  y_max : o͒lf[^͈́ilj
 * @param  dzoon : sюwiO`POOj
 * @retval (int) : o͒liWϊlj
 */
int rang_chg_dzoon(int x,int x_min,int x_max,int y_min,int y_max,int dzoon)
{
	int x_span,y_span;
	int x_mid,y_mid;
	int x_bias,y_bias;
	float _dzoon;
	float _xr,_xd,_y;
	int   x0,x_sign,y;

	x = Limit( x, x_min, x_max);
	x_span = x_max - x_min;
	y_span = y_max - y_min;
	x_mid  = x_span / 2;
	y_mid  = y_span / 2;
	x_bias = x_mid + x_min;
	y_bias = y_mid + y_min;
	_dzoon = (float)(dzoon/100.0);

	x0     = x - x_bias;
	x_sign = ((x0 >= 0) ? 1 : -1);
	_xr    = ((float)abs(x0)/(float)x_mid);
	_xd    = (float)(( _xr < _dzoon ) ? 0.0 : (((_xr - _dzoon)/(1.0 - _dzoon))*(float)x_sign));
	_y     = (float)(y_mid * _xd + y_bias);
	y      = (int)((_y >=0) ? (_y+0.5) : (_y-0.5));
	return (y);
}

/*----------------------------------------------------
@@@@\gp̃tHg
------------------------------------------------------*/
static HFONT  hFont_T0;
static HFONT  hFont_T1;
static HFONT  hFont_T2;

void Font_init(void)
{
	hFont_T0 = CreateFont( 17, 0, 0, 0,
				   	0,FALSE, FALSE, FALSE,
					SHIFTJIS_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					DEFAULT_QUALITY,
					FIXED_PITCH | FF_DONTCARE,
					"lr oSVbN" );

	hFont_T1 = CreateFont( 15, 0, 0, 0,
				   	FW_HEAVY,FALSE, FALSE, FALSE,
					ANSI_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					DEFAULT_QUALITY,
					FIXED_PITCH | FF_DONTCARE,
					"Arial" );

	hFont_T2 = CreateFont( 15, 0, 0, 0,
				   	FW_REGULAR,FALSE, FALSE, FALSE,
					SHIFTJIS_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					PROOF_QUALITY,
					FIXED_PITCH | FF_MODERN,
					"lr SVbN" );


}

/*----------------------------------------------------
@@@@\gp̃tHg폜
------------------------------------------------------*/
void Font_del(void)
{
	DeleteObject( hFont_T0 );
	DeleteObject( hFont_T1 );
	DeleteObject( hFont_T2 );
}

/*----------------------------------------------------
@@@@\gp̃tHgEnh[o
------------------------------------------------------*/
HFONT Font_set( int Font_ID )
{
	HFONT ans;

	switch(Font_ID)
	{
	case 0:
		ans = hFont_T0;
		break;
	case 1:
		ans = hFont_T1;
		break;
	case 2:
		ans = hFont_T2;
		break;
	default:
		ans = 0;
		break;
	}
	return (ans);
}

/*----------------------------------------------------
@@@@obNEJ[ؑ
------------------------------------------------------*/
COLORREF chg_BkColor( HDC hDC, unsigned char id)
{
	DWORD bk_c ;

	bk_c = RGB( 0,  0,  0);
	if ( id > 10/2  ) bk_c = RGB(  0,   0, 150);	// 10ms
	if ( id > 100/2 ) bk_c = RGB(100, 100,   0);	// 100ms
	if ( id > 200/2 ) bk_c = RGB(150,   0,   0);	// 500ms
	if ( id == 254  ) bk_c = RGB(  0, 150,   0);	// SIO -> UDP
	return (SetBkColor(hDC, bk_c));
}




//=============================================================================
//  XeAO@
//
int ST_control( int st, int st_param1, int st_param2 )
{
	int   st_out;
	int   sign;

#define  ST_MAX        (1000)
	if (abs(st) < st_param2) {
		/*-------------------------------------------------------*/
		/*  y = ax     x :͒l   y:o͒l
		/* 
		/*   a = y1 / x1
		/*     x1: o͕ω_  y1: o͕ω_ɂo͒l(=st_param1) 
		/*-------------------------------------------------------*/
		st_out = ((st_param1 * st) / st_param2);
	} else {
		sign = 1;
		if (st < 0) {
			sign = -sign;
		}
		/*-------------------------------------------------------*/
		/*  y = ax + b     x :͒l   y:o͒l
		/* 
		/*   a = (y_max - y1) / (x_max - x1)
		/*   b = y1
		/*     x_max: ő͒l  x1: o͕ω_
		/*     y_max: őo͒l  y1: o͕ω_ɂo͒l(=st_param1) 
		/*-------------------------------------------------------*/
		st_out = sign * ( (ST_MAX - st_param1) * (abs(st) - st_param2) / (ST_MAX - st_param2) + st_param1);
	}
	
	return (st_out);
}

int PW_control( int pw, int old_pw, int speed, int limit )
{
	int     e;   /* ΍ */
	static int     u = 0 ;   /*  */
	int     out_pw;
	static int aj_flg = 0 ;
	
#define KP             (2)	
	out_pw = pw ;
	if ( speed > limit )
	{
		e = speed - limit;	
//		u = KP * e;
		u = KP * limit;
		out_pw = Limit((old_pw - u), 0, 1000);
		aj_flg = 1 ;
	}
	else if( aj_flg != 0)
	{
		if ( pw > old_pw )
		{
			out_pw = Limit((old_pw + u), 0, 1000);
		}
		else aj_flg = 0;
	}
	
	return (out_pw);
}
