/*-----------------------------------------------------------------
  sub_module.h -- Subroutine Module Header File

  2006.11 Y.Katayama  Sanritz Automation Co., Ltd.
  ---------------------------------------------------------------*/
#ifndef _SUB_MODULE_H_
#define _SUB_MODULE_H_

#include <windows.h>

extern void str_repl(char *rd_msg, char s_char,char p_char ); // ̎w蕶wuɒu֐
extern void str_cut(char* rd_msg,char* scan_word);	// w蕶ȍ~؂藣֐
extern int Limit(int num,int min,int max); // ㉺Jbg
extern int rang_chg(int x,int x_min,int x_max,int y_min,int y_max);
extern int rang_chg_dzoon(int x,int x_min,int x_max,int y_min,int y_max,int dzoon);
extern int mov_avr(int val); // ړ(Moving Average)
extern int Chk_File( char* file_name ); // t@C̃`FbN

//================================================
extern int ST_control( int st, int st_param1, int st_param2 ); // XeAO@
extern int PW_control( int pw, int old_pw, int speed, int limit ); // p[
//================================================

extern int mov_avr2(int val); // ړ(Moving Average)
extern int rang_chg(int x,int x_min,int x_max,int y_min,int y_max);

extern void Font_init(void);
extern void Font_del(void);
extern HFONT Font_set( int Font_ID );
extern COLORREF chg_BkColor( HDC hDC, unsigned char id);

class MV_avr
{
public:
	MV_avr();
	virtual ~MV_avr();
	void init(int mx);
	int cal(int val);
protected:
	int mx_cnt;
	int inx;
	int cnt;
	int addsum;
	int *num;
};

class TM
{
public:
	TM();
	virtual ~TM();
	void init(int mx);
	void Start(void);
	void End(void);
	void Set(int val);
	void Clr(void);
	void dsp_time(HDC hdc, int x, int y);
	void dsp_time(HDC hdc, int x, int y, char *str);
	void dsp_time(HDC hdc, int x, int y, int jpeg_sz);
	void dsp_time(HDC hdc, int x, int y, int jpeg_sz, char *str);
	DWORD TM_min;
	DWORD TM_max;
	DWORD TM_ave;
	DWORD TM_now;
protected:
	DWORD TM_prev;
	MV_avr *m_avr;
};

#endif /* ifndef _SUB_MODULE_H_ */
